Qt 5.6 | Qt 3D | C++ Classes | QPhongMaterial

Qt 5.6.3 Reference Documentation

# QPhongMaterial Class

(Qt3DRender::QPhongMaterial)

The QPhongMaterial class provides a default implementation of the phong lighting effect. More...

Header: | #include <QPhongMaterial>
qmake: | QT += 3drender
Since: | Qt 5.5
Inherits: | QMaterial

- List of all members, including inherited members

## Properties

- ambient : QColor
- diffuse : QColor
- shininess : float
- specular : QColor

- 1 property inherited from Qt3DRender::QMaterial
- 1 property inherited from Qt3DCore::QComponent
- 2 properties inherited from Qt3DCore::QNode

## Public Functions

| QPhongMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)
| ~QPhongMaterial()
QColor | ambient() const
QColor | diffuse() const
float | shininess() const
QColor | specular() const

- 6 public functions inherited from Qt3DRender::QMaterial
- 2 public functions inherited from Qt3DCore::QComponent
- 6 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setAmbient(const QColor &ambient)
void | setDiffuse(const QColor &diffuse)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)

- 1 public slot inherited from Qt3DRender::QMaterial
- 1 public slot inherited from Qt3DCore::QComponent
- 2 public slots inherited from Qt3DCore::QNode

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(const QColor &diffuse)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)

- 1 signal inherited from Qt3DRender::QMaterial
- 2 signals inherited from Qt3DCore::QComponent
- 2 signals inherited from Qt3DCore::QNode

### Additional Inherited Members

- 1 protected function inherited from Qt3DRender::QMaterial
- 1 protected function inherited from Qt3DCore::QComponent
- 3 protected functions inherited from Qt3DCore::QNode
- 1 static protected member inherited from Qt3DCore::QNode

## Detailed Description

The QPhongMaterial class provides a default implementation of the phong lighting effect.

The phong lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components is controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : QColor

Holds the diffuse color.

Access functions:

QColor | diffuse() const
void | setDiffuse(const QColor &diffuse)

Notifier signal:

void | diffuseChanged(const QColor &diffuse)

### shininess : float

Holds the shininess exponent.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

## Member Function Documentation

### QPhongMaterial::QPhongMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)

Constructs a new QPhongMaterial instance with parent object parent.

### QPhongMaterial::~QPhongMaterial()

Destroys the QPhongMaterial.